
function trim(s:string):string;
begin
  while (length(s)>0) and (s[1]=' ') do delete(S,1,1);
  while (length(s)>0) and (s[length(s)]=' ') do delete(S,1,1);
  trim := s;
end;

function uppercase(s:string):string;
var i:byte;
begin
  for i := 1 to length(s) do
    s[i] := upcase(s[i]);
  uppercase := s;
end;

type TStrings = array[1..1000] of ^string;

var badigms : TStrings;
    igms    : TStrings;
    partydat : text;
    data:file;
    s,s2:string;
    badc,loadedc:byte;
    c,i,j:byte;
    arr:array[1..13] of char;
    ch:char;
    found : boolean;
    lordpath:string;
    igmpath:string;
    ioerror:integer;
begin

  writeln('Opening 3rdparty.dat');
  writeln;

  assign(partydat,'3RDPARTY.DAT');
  {$I-}reset(partydat);{$I+}
  ioerror := ioresult;

  if ioerror<>0 then
  begin
    if ioerror = 2 then
    begin
      writeln('3rdpaty.dat not found in current directory');
      writeln('Please enter the path to 3rdparty.dat (without the filename)');
      write('-> ');
      readln(lordpath);
      lordpath := trim(lordpath);
      if lordpath[length(lordpath)] <> '\' then
        lordpath := lordpath + '\';
      assign(partydat,lordpath+'3rdparty.dat');
      {$I-}reset(partydat);{$I+}
      ioerror := ioresult;
      if ioerror <> 0 then
      begin
        writeln('IOError ',ioerror,' from that path');
        writeln('Giving up.');
        halt;
      end;
    end
    else
    begin
      writeln('IOError ',ioerror,' while opening 3rdparty.dat');
      writeln('Exiting');
      halt;
    end;
  end;

  writeln('Opening IGMINFO.DAT');
  writeln;

  assign(data,'IGMINFO.DAT');
  {$I-}reset(data,1);{$I+}
  ioerror := ioresult;
  if ioerror <> 0 then
  begin
    if ioerror = 2 then
    begin
      writeln('IGMINFO.DAT not found in current directory.');
      writeln('Please enter path to file (but not the filename)');
      write('-> ');
      readln(igmpath);

      if igmpath[length(igmpath)] <> '\' then
        igmpath := igmpath + '\';

      assign(data,igmpath+'IGMINFO.DAT');
      {$I-}reset(data,1);{$I+}
      ioerror := ioresult;
      if ioerror <> 0 then
      begin
        close(partydat);
        writeln('IOError ',ioerror,' while opening that path.');
        writeln('Giving up.');
        halt;
      end;
    end
    else
    begin
      close(partydat);
      writeln('IOError ',ioerror,' while opening IGMINFO.DAT');
      writeln('Exiting');
      halt;
    end;
  end;



  writeln('loading 3rdparty.dat');
  writeln;

  loadedc := 0;
  c := 0;
  while (not eof(partydat)) and (loadedc <= 100) do
  begin
    readln(partydat,s);
    inc(c);
    if not odd(c) then continue;
    s := trim(s);
    if s[1] <> ';' then
    begin
      inc(loadedc);
      if pos(' ',s) > 0 then
        delete(s,pos(' ',s),255);
      if pos('\',s)<> 0 then
      begin
        s2 := '';
        i := length(s);
        while s[i] <> '\' do
        begin
          s2 := s[i] + s2;
          dec(i);
        end;
      end
      else
        s2 := s;
      if pos('.',s2) = 0 then
      begin
        writeln('The following line from 3RDPARTY.DAT is illegal!');
        writeln(s);
      end
      else
      begin
        new(igms[loadedc]);
        igms[loadedc]^ := uppercase(s2);
      end;
    end;
  end;

  close(partydat);

  writeln('loading igminfo.dat');
  writeln;

  badc := 1;
  while (not eof(data)) and (badc <= 100) do
  begin
    s := '';
    blockread(data,arr,sizeof(arr));
    i := 1;
    while (i < 20) and (arr[i] <> #0) do
    begin
      s := s + arr[i];
      inc(i);
    end;
    new(badigms[badc]);
    badigms[badc]^ := uppercase(s);
    inc(badc);
  end;

  close(data);

  writeln('Comparing data');
  writeln;

  for i := 1 to loadedc do
  begin
    found := false;
    j := 1;
    while (Found = false) and (j <= 100) do
    begin
      if igms[i]^ = badigms[j]^ then
      begin
        found := true;
      end;
      inc(j);
    end;
    if found = false then
      writeln('BAD IGM: 3rd: ',igms[i]^,' - igminfo: ',badigms[j]^);
  end;

  writeln('Done. If you saw no "BAD IGM" messages, youre clean.');
  writeln;

  for i := 1 to loadedc-1 do
    dispose(igms[i]);

  for i := 1 to badc-1 do
    dispose(badigms[i]);

end.
